diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/recipient-block-ack-agreement.cc ns-3.44/src/wifi/model/recipient-block-ack-agreement.cc
--- ns-3.43/src/wifi/model/recipient-block-ack-agreement.cc	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/recipient-block-ack-agreement.cc	2025-03-09 16:55:49.799372700 -0700
@@ -159,8 +159,10 @@
         // MAC process in order of increasing Sequence Number subfield value. Gaps may
         // exist in the Sequence Number subfield values of the MSDUs or A-MSDUs that are
         // passed up to the next MAC process.
-        PassBufferedMpdusWithSeqNumberLessThan(mpdu->GetHeader().GetSequenceNumber() - m_winSizeB +
-                                               1);
+        const uint16_t newWinStartB =
+            (mpdu->GetHeader().GetSequenceNumber() - m_winSizeB + 1 + SEQNO_SPACE_SIZE) %
+            SEQNO_SPACE_SIZE;
+        PassBufferedMpdusWithSeqNumberLessThan(newWinStartB);
 
         // 5. Pass MSDUs or A-MSDUs stored in the buffer up to the next MAC process in
         // order of increasing value of the Sequence Number subfield starting with
@@ -218,20 +220,20 @@
 }
 
 void
-RecipientBlockAckAgreement::FillBlockAckBitmap(CtrlBAckResponseHeader* blockAckHeader,
+RecipientBlockAckAgreement::FillBlockAckBitmap(CtrlBAckResponseHeader& blockAckHeader,
                                                std::size_t index) const
 {
     NS_LOG_FUNCTION(this << blockAckHeader << index);
-    if (blockAckHeader->IsBasic())
+    if (blockAckHeader.IsBasic())
     {
         NS_FATAL_ERROR("Basic block ack is not supported.");
     }
-    else if (blockAckHeader->IsMultiTid())
+    else if (blockAckHeader.IsMultiTid())
     {
         NS_FATAL_ERROR("Multi-tid block ack is not supported.");
     }
-    else if (blockAckHeader->IsCompressed() || blockAckHeader->IsExtendedCompressed() ||
-             blockAckHeader->IsMultiSta())
+    else if (blockAckHeader.IsCompressed() || blockAckHeader.IsExtendedCompressed() ||
+             blockAckHeader.IsMultiSta() || blockAckHeader.IsGcr())
     {
         // The Starting Sequence Number subfield of the Block Ack Starting Sequence
         // Control subfield of the BlockAck frame shall be set to any value in the
@@ -239,14 +241,14 @@
         // We set it to WinStartR
         uint16_t ssn = m_scoreboard.GetWinStart();
         NS_LOG_DEBUG("SSN=" << ssn);
-        blockAckHeader->SetStartingSequence(ssn, index);
-        blockAckHeader->ResetBitmap(index);
+        blockAckHeader.SetStartingSequence(ssn, index);
+        blockAckHeader.ResetBitmap(index);
 
         for (std::size_t i = 0; i < m_scoreboard.GetWinSize(); i++)
         {
             if (m_scoreboard.At(i))
             {
-                blockAckHeader->SetReceivedPacket((ssn + i) % SEQNO_SPACE_SIZE, index);
+                blockAckHeader.SetReceivedPacket((ssn + i) % SEQNO_SPACE_SIZE, index);
             }
         }
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/recipient-block-ack-agreement.h ns-3.44/src/wifi/model/recipient-block-ack-agreement.h
--- ns-3.43/src/wifi/model/recipient-block-ack-agreement.h	2024-10-09 16:41:10.124656700 -0700
+++ ns-3.44/src/wifi/model/recipient-block-ack-agreement.h	2025-03-09 16:55:49.799372700 -0700
@@ -21,7 +21,7 @@
 class CtrlBAckResponseHeader;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Maintains the scoreboard and the receive reordering buffer used by a recipient
  * of a Block Ack agreement.
  */
@@ -31,13 +31,13 @@
     /**
      * Constructor
      *
-     * \param originator MAC address
-     * \param amsduSupported whether A-MSDU support is enabled
-     * \param tid Traffic ID
-     * \param bufferSize the buffer size (in number of MPDUs)
-     * \param timeout the timeout value
-     * \param startingSeq the starting sequence number
-     * \param htSupported whether HT support is enabled
+     * @param originator MAC address
+     * @param amsduSupported whether A-MSDU support is enabled
+     * @param tid Traffic ID
+     * @param bufferSize the buffer size (in number of MPDUs)
+     * @param timeout the timeout value
+     * @param startingSeq the starting sequence number
+     * @param htSupported whether HT support is enabled
      */
     RecipientBlockAckAgreement(Mac48Address originator,
                                bool amsduSupported,
@@ -51,7 +51,7 @@
     /**
      * Set the MAC RX Middle to use.
      *
-     * \param rxMiddle the MAC RX Middle to use
+     * @param rxMiddle the MAC RX Middle to use
      */
     void SetMacRxMiddle(const Ptr<MacRxMiddle> rxMiddle);
 
@@ -59,14 +59,14 @@
      * Update both the scoreboard and the receive reordering buffer upon reception
      * of the given MPDU.
      *
-     * \param mpdu the received MPDU
+     * @param mpdu the received MPDU
      */
     void NotifyReceivedMpdu(Ptr<const WifiMpdu> mpdu);
     /**
      * Update both the scoreboard and the receive reordering buffer upon reception
      * of a Block Ack Request.
      *
-     * \param startingSequenceNumber the starting sequence number included in the
+     * @param startingSequenceNumber the starting sequence number included in the
      *                               received Block Ack Request
      */
     void NotifyReceivedBar(uint16_t startingSequenceNumber);
@@ -76,10 +76,10 @@
      * For Multi-STA Block Acks, <i>index</i> identifies the Per AID TID Info
      * subfield whose bitmap has to be filled.
      *
-     * \param blockAckHeader the block ack header
-     * \param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
+     * @param blockAckHeader the block ack header
+     * @param index the index of the Per AID TID Info subfield (Multi-STA Block Ack only)
      */
-    void FillBlockAckBitmap(CtrlBAckResponseHeader* blockAckHeader, std::size_t index = 0) const;
+    void FillBlockAckBitmap(CtrlBAckResponseHeader& blockAckHeader, std::size_t index = 0) const;
     /**
      * This is called when a Block Ack agreement is destroyed to flush the
      * received packets.
@@ -101,7 +101,7 @@
      * subfield values that are lower than the new value of WinStartB up to the next
      * MAC process in order of increasing Sequence Number subfield value.
      *
-     * \param newWinStartB the new value of WinStartB
+     * @param newWinStartB the new value of WinStartB
      */
     void PassBufferedMpdusWithSeqNumberLessThan(uint16_t newWinStartB);
 
@@ -114,9 +114,9 @@
         /**
          * Functional operator for sorting the buffered MPDUs.
          *
-         * \param a the key of first buffered MPDU (\see Key)
-         * \param b the key of second buffered MPDU (\see Key)
-         * \return true if first key is smaller than second
+         * @param a the key of first buffered MPDU (\see Key)
+         * @param b the key of second buffered MPDU (\see Key)
+         * @return true if first key is smaller than second
          */
         bool operator()(const Key& a, const Key& b) const;
     };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/reduced-neighbor-report.cc ns-3.44/src/wifi/model/reduced-neighbor-report.cc
--- ns-3.43/src/wifi/model/reduced-neighbor-report.cc	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/reduced-neighbor-report.cc	2025-03-09 16:55:49.799372700 -0700
@@ -9,6 +9,7 @@
 #include "reduced-neighbor-report.h"
 
 #include "wifi-phy-operating-channel.h"
+#include "wifi-utils.h"
 
 #include "ns3/abort.h"
 #include "ns3/address-utils.h"
@@ -53,17 +54,17 @@
     switch (channel.GetPhyBand())
     {
     case WIFI_PHY_BAND_2_4GHZ:
-        if (channel.GetWidth() == 20)
+        if (channel.GetWidth() == MHz_u{20})
         {
             operatingClass = 81;
         }
-        else if (channel.GetWidth() == 40)
+        else if (channel.GetWidth() == MHz_u{40})
         {
             operatingClass = 83;
         }
         break;
     case WIFI_PHY_BAND_5GHZ:
-        if (channel.GetWidth() == 20)
+        if (channel.GetWidth() == MHz_u{20})
         {
             if (channelNumber == 36 || channelNumber == 40 || channelNumber == 44 ||
                 channelNumber == 48)
@@ -89,7 +90,7 @@
                 operatingClass = 125;
             }
         }
-        else if (channel.GetWidth() == 40)
+        else if (channel.GetWidth() == MHz_u{40})
         {
             if (channelNumber == 38 || channelNumber == 46)
             {
@@ -110,7 +111,7 @@
                 operatingClass = 126;
             }
         }
-        else if (channel.GetWidth() == 80)
+        else if (channel.GetWidth() == MHz_u{80})
         {
             if (channelNumber == 42 || channelNumber == 58 || channelNumber == 106 ||
                 channelNumber == 122 || channelNumber == 138 || channelNumber == 155 ||
@@ -119,7 +120,7 @@
                 operatingClass = 128;
             }
         }
-        else if (channel.GetWidth() == 160)
+        else if (channel.GetWidth() == MHz_u{160})
         {
             if (channelNumber == 50 || channelNumber == 114 || channelNumber == 163)
             {
@@ -128,19 +129,19 @@
         }
         break;
     case WIFI_PHY_BAND_6GHZ:
-        if (channel.GetWidth() == 20)
+        if (channel.GetWidth() == MHz_u{20})
         {
             operatingClass = 131;
         }
-        else if (channel.GetWidth() == 40)
+        else if (channel.GetWidth() == MHz_u{40})
         {
             operatingClass = 132;
         }
-        else if (channel.GetWidth() == 80)
+        else if (channel.GetWidth() == MHz_u{80})
         {
             operatingClass = 133;
         }
-        else if (channel.GetWidth() == 160)
+        else if (channel.GetWidth() == MHz_u{160})
         {
             operatingClass = 134;
         }
@@ -157,18 +158,18 @@
                         << "band " << channel.GetPhyBand());
 
     // find the primary channel number
-    MHz_u startingFreq = 0;
+    MHz_u startingFreq{0};
 
     switch (channel.GetPhyBand())
     {
     case WIFI_PHY_BAND_2_4GHZ:
-        startingFreq = 2407;
+        startingFreq = MHz_u{2407};
         break;
     case WIFI_PHY_BAND_5GHZ:
-        startingFreq = 5000;
+        startingFreq = MHz_u{5000};
         break;
     case WIFI_PHY_BAND_6GHZ:
-        startingFreq = 5950;
+        startingFreq = MHz_u{5950};
         break;
     case WIFI_PHY_BAND_UNSPECIFIED:
     default:
@@ -177,7 +178,7 @@
     }
 
     uint8_t primaryChannelNumber =
-        (channel.GetPrimaryChannelCenterFrequency(20) - startingFreq) / 5;
+        (channel.GetPrimaryChannelCenterFrequency(MHz_u{20}) - startingFreq) / MHz_u{5};
 
     m_nbrApInfoFields.at(nbrApInfoId).operatingClass = operatingClass;
     m_nbrApInfoFields.at(nbrApInfoId).channelNumber = primaryChannelNumber;
@@ -189,74 +190,74 @@
     NS_ASSERT(nbrApInfoId < m_nbrApInfoFields.size());
 
     WifiPhyBand band = WIFI_PHY_BAND_UNSPECIFIED;
-    MHz_u width = 0;
+    MHz_u width{0};
 
     switch (m_nbrApInfoFields.at(nbrApInfoId).operatingClass)
     {
     case 81:
         band = WIFI_PHY_BAND_2_4GHZ;
-        width = 20;
+        width = MHz_u{20};
         break;
     case 83:
         band = WIFI_PHY_BAND_2_4GHZ;
-        width = 40;
+        width = MHz_u{40};
         break;
     case 115:
     case 118:
     case 121:
     case 125:
         band = WIFI_PHY_BAND_5GHZ;
-        width = 20;
+        width = MHz_u{20};
         break;
     case 116:
     case 119:
     case 122:
     case 126:
         band = WIFI_PHY_BAND_5GHZ;
-        width = 40;
+        width = MHz_u{40};
         break;
     case 128:
         band = WIFI_PHY_BAND_5GHZ;
-        width = 80;
+        width = MHz_u{80};
         break;
     case 129:
         band = WIFI_PHY_BAND_5GHZ;
-        width = 160;
+        width = MHz_u{160};
         break;
     case 131:
         band = WIFI_PHY_BAND_6GHZ;
-        width = 20;
+        width = MHz_u{20};
         break;
     case 132:
         band = WIFI_PHY_BAND_6GHZ;
-        width = 40;
+        width = MHz_u{40};
         break;
     case 133:
         band = WIFI_PHY_BAND_6GHZ;
-        width = 80;
+        width = MHz_u{80};
         break;
     case 134:
         band = WIFI_PHY_BAND_6GHZ;
-        width = 160;
+        width = MHz_u{160};
         break;
     default:
         break;
     }
 
-    NS_ABORT_IF(band == WIFI_PHY_BAND_UNSPECIFIED || width == 0);
+    NS_ABORT_IF(band == WIFI_PHY_BAND_UNSPECIFIED || width == MHz_u{0});
 
-    MHz_u startingFreq = 0;
+    MHz_u startingFreq{0};
 
     switch (band)
     {
     case WIFI_PHY_BAND_2_4GHZ:
-        startingFreq = 2407;
+        startingFreq = MHz_u{2407};
         break;
     case WIFI_PHY_BAND_5GHZ:
-        startingFreq = 5000;
+        startingFreq = MHz_u{5000};
         break;
     case WIFI_PHY_BAND_6GHZ:
-        startingFreq = 5950;
+        startingFreq = MHz_u{5950};
         break;
     case WIFI_PHY_BAND_UNSPECIFIED:
     default:
@@ -265,10 +266,10 @@
     }
 
     uint8_t primaryChannelNumber = m_nbrApInfoFields.at(nbrApInfoId).channelNumber;
-    MHz_u primaryChannelCenterFrequency = startingFreq + primaryChannelNumber * 5;
+    auto primaryChannelCenterFrequency = startingFreq + primaryChannelNumber * MHz_u{5};
 
     uint8_t channelNumber = 0;
-    MHz_u frequency = 0;
+    MHz_u frequency{0};
 
     for (const auto& channel : WifiPhyOperatingChannel::m_frequencyChannels)
     {
@@ -299,8 +300,8 @@
                     }
                     break;
                 case 40:
-                    if ((channel.frequency == primaryChannelCenterFrequency + 10) ||
-                        (channel.frequency == primaryChannelCenterFrequency - 10))
+                    if ((channel.frequency == primaryChannelCenterFrequency + MHz_u{10}) ||
+                        (channel.frequency == primaryChannelCenterFrequency - MHz_u{10}))
                     {
                         found = true;
                     }
@@ -319,14 +320,14 @@
         }
     }
 
-    NS_ABORT_IF(channelNumber == 0 || frequency == 0);
+    NS_ABORT_IF(channelNumber == 0 || frequency == MHz_u{0});
 
     WifiPhyOperatingChannel channel;
     channel.Set({{channelNumber, frequency, width, band}}, WIFI_STANDARD_UNSPECIFIED);
 
-    MHz_u channelLowestFreq = frequency - width / 2;
-    MHz_u primaryChannelLowestFreq = primaryChannelCenterFrequency - 10;
-    channel.SetPrimary20Index((primaryChannelLowestFreq - channelLowestFreq) / 20);
+    const auto channelLowestFreq = frequency - width / 2;
+    const auto primaryChannelLowestFreq = primaryChannelCenterFrequency - MHz_u{10};
+    channel.SetPrimary20Index(Count20MHzSubchannels(channelLowestFreq, primaryChannelLowestFreq));
 
     return channel;
 }
@@ -519,17 +520,13 @@
 void
 ReducedNeighborReport::SetMldParameters(std::size_t nbrApInfoId,
                                         std::size_t index,
-                                        uint8_t mldId,
-                                        uint8_t linkId,
-                                        uint8_t changeCount)
+                                        const MldParameters& mldParams)
 {
     NS_ASSERT(nbrApInfoId < m_nbrApInfoFields.size());
     NS_ASSERT(index < m_nbrApInfoFields.at(nbrApInfoId).tbttInformationSet.size());
 
     auto it = std::next(m_nbrApInfoFields.at(nbrApInfoId).tbttInformationSet.begin(), index);
-    it->mldParameters.mldId = mldId;
-    it->mldParameters.linkId = (linkId & 0x0f);
-    it->mldParameters.bssParamsChangeCount = changeCount;
+    it->mldParameters = mldParams;
 
     m_nbrApInfoFields.at(nbrApInfoId).hasMldParams = true;
 }
@@ -542,23 +539,13 @@
     return m_nbrApInfoFields.at(nbrApInfoId).hasMldParams;
 }
 
-uint8_t
-ReducedNeighborReport::GetMldId(std::size_t nbrApInfoId, std::size_t index) const
-{
-    NS_ASSERT(HasMldParameters(nbrApInfoId));
-    NS_ASSERT(index < m_nbrApInfoFields.at(nbrApInfoId).tbttInformationSet.size());
-
-    return m_nbrApInfoFields.at(nbrApInfoId).tbttInformationSet.at(index).mldParameters.mldId;
-}
-
-uint8_t
-ReducedNeighborReport::GetLinkId(std::size_t nbrApInfoId, std::size_t index) const
+const ReducedNeighborReport::MldParameters&
+ReducedNeighborReport::GetMldParameters(std::size_t nbrApInfoId, std::size_t index) const
 {
     NS_ASSERT(HasMldParameters(nbrApInfoId));
     NS_ASSERT(index < m_nbrApInfoFields.at(nbrApInfoId).tbttInformationSet.size());
 
-    return m_nbrApInfoFields.at(nbrApInfoId).tbttInformationSet.at(index).mldParameters.linkId &
-           0x0f;
+    return m_nbrApInfoFields.at(nbrApInfoId).tbttInformationSet.at(index).mldParameters;
 }
 
 void
@@ -660,10 +647,12 @@
             }
             if (neighborApInfo.hasMldParams)
             {
-                start.WriteU8(tbttInformation.mldParameters.mldId);
+                start.WriteU8(tbttInformation.mldParameters.apMldId);
                 uint16_t other = 0;
                 other |= (tbttInformation.mldParameters.linkId & 0x0f);
                 other |= (tbttInformation.mldParameters.bssParamsChangeCount << 4);
+                other |= (tbttInformation.mldParameters.allUpdates << 12);
+                other |= (tbttInformation.mldParameters.disabledLink << 13);
                 start.WriteHtolsbU16(other);
             }
         }
@@ -722,14 +711,14 @@
             }
             if (m_nbrApInfoFields.back().hasMldParams)
             {
-                m_nbrApInfoFields.back().tbttInformationSet.back().mldParameters.mldId = i.ReadU8();
+                auto& mldParams = m_nbrApInfoFields.back().tbttInformationSet.back().mldParameters;
+                mldParams.apMldId = i.ReadU8();
                 uint16_t other = i.ReadLsbtohU16();
                 count += 3;
-                m_nbrApInfoFields.back().tbttInformationSet.back().mldParameters.linkId =
-                    other & 0x000f;
-                m_nbrApInfoFields.back()
-                    .tbttInformationSet.back()
-                    .mldParameters.bssParamsChangeCount = (other >> 4) & 0x00ff;
+                mldParams.linkId = other & 0x000f;
+                mldParams.bssParamsChangeCount = (other >> 4) & 0x00ff;
+                mldParams.allUpdates = (other >> 12) & 0x01;
+                mldParams.disabledLink = (other >> 13) & 0x01;
             }
         }
     }
